> ## Documentation Index
> Fetch the complete documentation index at: https://developers.askparable.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Start a Provider OAuth sign-in

> Starts the OAuth 2.0 authorization code flow for a Provider connection in this Workspace and returns the Provider's authorization URL. The same person opens the URL in a browser within 10 minutes. redirectUri is the Parable app's Provider OAuth callback page, which completes the flow and saves the credentials. Send your OAuth application's clientId and clientSecret. After the first sign-in, the saved secret is used when clientSecret is empty. Requires permission to manage Provider connection secrets.

## Access

This operation needs a Parable token. An MCP token cannot call it. See [Authentication](/getting-started/authentication.md) for the kinds of token.

Your roles must grant `tenant.connectors.secrets`.

## Errors

* `HTTP 400`: The connection does not use the OAuth 2.0 authorization code flow, redirectUri is not the Parable OAuth callback page, or clientId is missing. Use an OAuth connection, the callback page address, and your OAuth application client ID.
* `HTTP 404`: The Provider connection was not found in this Workspace. Check the connection identifier.


## OpenAPI

````yaml /api-reference/openapi.json post /api/connectors/connector-oauth-start
openapi: 3.0.3
info:
  description: >-
    Use the Workspace API to work with artifacts, connectors, Parables, and
    account resources.
  title: Workspace API
  version: v2026.10.22.1
servers: []
security: []
paths:
  /api/connectors/connector-oauth-start:
    post:
      tags:
        - Connectors
      summary: Start a Provider OAuth sign-in
      description: >-
        Starts the OAuth 2.0 authorization code flow for a Provider connection
        in this Workspace and returns the Provider's authorization URL. The same
        person opens the URL in a browser within 10 minutes. redirectUri is the
        Parable app's Provider OAuth callback page, which completes the flow and
        saves the credentials. Send your OAuth application's clientId and
        clientSecret. After the first sign-in, the saved secret is used when
        clientSecret is empty. Requires permission to manage Provider connection
        secrets.
      operationId: ConnectorsConnectorOAuthStartHandler
      parameters:
        - description: >-
            Workspace slug. Overrides subdomain-based workspace resolution when
            provided.
          in: header
          name: X-Tenant
          required: false
          schema:
            example: acme
            type: string
        - description: Optional request correlation ID echoed back in the response.
          in: header
          name: X-Request-ID
          required: false
          schema:
            example: 550e8400-e29b-41d4-a716-446655440000
            format: uuid
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ConnectorOAuthStartInput'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                properties:
                  data:
                    $ref: '#/components/schemas/ConnectorOAuthStartResult'
                  links:
                    $ref: '#/components/schemas/ResponseLinks'
                  meta:
                    $ref: '#/components/schemas/ResponseMeta'
                required:
                  - data
                  - meta
                type: object
          description: Successful response
          headers:
            X-Request-ID:
              $ref: '#/components/headers/X-Request-ID'
        '400':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetails'
          description: >-
            The request is not valid. `detail` says why. A value that breaks a
            field rule gives the code `WA-VL-001` and an `errors` member that
            names each field.
          headers:
            X-Request-ID:
              $ref: '#/components/headers/X-Request-ID'
        '401':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetails'
          description: The token is missing, malformed, revoked, or expired.
          headers:
            X-Request-ID:
              $ref: '#/components/headers/X-Request-ID'
        '403':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetails'
          description: >-
            The token cannot make this request. For example, the roles of its
            owner do not allow the operation.
          headers:
            X-Request-ID:
              $ref: '#/components/headers/X-Request-ID'
        '500':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetails'
          description: The request failed on the server.
          headers:
            X-Request-ID:
              $ref: '#/components/headers/X-Request-ID'
      security:
        - bearerAuth: []
      x-codeSamples:
        - label: TypeScript SDK
          lang: typescript
          source: >-
            import { WebApiSDK } from "@parable-platform/web-api-sdk";

            import type { ConnectorOAuthStartInput } from
            "@parable-platform/web-api-types";


            const sdk = new WebApiSDK({
              baseUrl: process.env.PARABLE_API_URL!,
              auth: { token: process.env.PARABLE_API_TOKEN! },
              requestInterceptor: (config) => ({
                ...config,
                headers: { ...config.headers, "X-Tenant": process.env.PARABLE_WORKSPACE! },
              }),
            });


            const input: ConnectorOAuthStartInput = JSON.parse(`{
              "tenantConnectorId": "550e8400-e29b-41d4-a716-446655440000",
              "clientId": "example",
              "clientSecret": "example",
              "redirectUri": "https://example.com"
            }`);

            const result = await sdk.connectors.connectorOAuthStart(
              input
            );
        - label: Python SDK
          lang: python
          source: |-
            import json
            import os

            from parable_types_web_api import ConnectorOAuthStartInput
            from parable_web_api_sdk import ClientConfig, WebApiSDK

            sdk = WebApiSDK(
                ClientConfig(
                    base_url=os.environ["PARABLE_API_URL"],
                    auth_token=os.environ["PARABLE_API_TOKEN"],
                    default_headers={"X-Tenant": os.environ["PARABLE_WORKSPACE"]},
                )
            )

            input_data = ConnectorOAuthStartInput.model_validate(
                json.loads("{\"tenantConnectorId\":\"550e8400-e29b-41d4-a716-446655440000\",\"clientId\":\"example\",\"clientSecret\":\"example\",\"redirectUri\":\"https://example.com\"}"),
            )
            result = sdk.connectors.connector_oauth_start(input_data)
        - label: Rust SDK
          lang: rust
          source: >-
            use parable_web_api_sdk::{types, ClientConfig, RequestOptions,
            WebApiSdk};


            let sdk = WebApiSdk::new(ClientConfig::with_base_url(
                std::env::var("PARABLE_API_URL")?,
                Some(std::env::var("PARABLE_API_TOKEN")?),
                None,
            ))?;

            let options = RequestOptions::with_header("X-Tenant",
            std::env::var("PARABLE_WORKSPACE")?, None, None);


            let input: types::ConnectorOAuthStartInput = serde_json::from_value(
                serde_json::json!({
              "tenantConnectorId": "550e8400-e29b-41d4-a716-446655440000",
              "clientId": "example",
              "clientSecret": "example",
              "redirectUri": "https://example.com"
            }),

            )?;

            let result = sdk.connectors.connector_oauth_start(
                input,
                Some(&options)
            ).await?;
        - label: Go SDK
          lang: go
          source: "sdk, err := webapisdk.New(webapisdk.SDKConfig{\n\tBaseURL: os.Getenv(\"PARABLE_API_URL\"),\n\tAuth:    &webapisdk.AuthConfig{Token: os.Getenv(\"PARABLE_API_TOKEN\")},\n\tRequestInterceptor: func(ctx context.Context, req *http.Request) error {\n\t\treq.Header.Set(\"X-Tenant\", os.Getenv(\"PARABLE_WORKSPACE\"))\n\t\treturn nil\n\t},\n})\nif err != nil {\n\treturn err\n}\n\nvar input webapitypes.ConnectorOAuthStartInput\nif err := json.Unmarshal([]byte(`{\"tenantConnectorId\":\"550e8400-e29b-41d4-a716-446655440000\",\"clientId\":\"example\",\"clientSecret\":\"example\",\"redirectUri\":\"https://example.com\"}`), &input); err != nil {\n\treturn err\n}\nresult, err := sdk.ConnectorsNamespace.ConnectorOAuthStart(ctx, input)"
components:
  schemas:
    ConnectorOAuthStartInput:
      properties:
        clientId:
          type: string
        clientSecret:
          type: string
        redirectUri:
          description: RFC 3986 URI for connection strings and non-HTTP resources
          format: uri
          maxLength: 4096
          pattern: ^[a-zA-Z][a-zA-Z0-9+.-]*://[^\s]+$
          type: string
        tenantConnectorId:
          description: UUID v4 with automatic base62 encoding for client-facing APIs
          pattern: >-
            ^([0-9A-Za-z]{1,22}|[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12})$
          type: string
      required:
        - tenantConnectorId
        - clientId
        - clientSecret
        - redirectUri
      type: object
    ConnectorOAuthStartResult:
      properties:
        authorizeUrl:
          description: Valid HTTP/HTTPS URL
          format: uri
          maxLength: 2048
          pattern: >-
            ^https?://[\w\-\{\}]+(\.[\w\-\{\}]+)+([:/?#][\w\-\._~:/?#\[\]@!\$&'\(\)\*\+,;=\{\}%]*)?$
          type: string
      required:
        - authorizeUrl
      type: object
    ResponseLinks:
      properties:
        first:
          nullable: true
          type: string
        last:
          nullable: true
          type: string
        next:
          nullable: true
          type: string
        prev:
          nullable: true
          type: string
      type: object
    ResponseMeta:
      properties:
        requestId:
          description: Unique identifier for the request
          type: string
        totalCount:
          description: Total count of items for paginated responses
          nullable: true
          type: integer
      required:
        - requestId
      type: object
    ProblemDetails:
      description: An error response in the Problem Details format (RFC 9457).
      properties:
        code:
          description: The stable error code, when the problem has one.
          example: WA-VL-001
          type: string
        detail:
          description: What went wrong with this request.
          type: string
        details:
          description: >-
            Structured facts about the refusal, such as the entity or the path
            it concerns. Only some refusals have it.
        errors:
          description: >-
            The fields or filters that failed validation. Only a validation or
            filter error has it.
        requestId:
          description: >-
            The ID of the request, when the problem has one. The `X-Request-ID`
            response header always has it.
          type: string
        status:
          description: The HTTP status code.
          example: 400
          type: integer
        title:
          description: A short summary, usually the text of the HTTP status.
          example: Bad Request
          type: string
        type:
          description: >-
            The problem type. It is `about:blank`: the status and `code`
            identify the problem.
          example: about:blank
          type: string
      required:
        - type
        - title
        - status
        - detail
      type: object
  headers:
    X-Request-ID:
      description: >-
        The ID of the request. It is the `X-Request-ID` value that you sent, or
        an ID that the server made. Give it when you report a problem.
      schema:
        type: string
  securitySchemes:
    bearerAuth:
      description: >-
        A personal access token, which starts with `pat_`. A Parable token can
        call each operation that the roles of its owner allow. An MCP token can
        call only the read operations that are open to agents. A SQL token does
        not work on this API.
      scheme: bearer
      type: http

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.